unit UnitMojForm;

interface

uses
  Windows, SysUtils, Forms, Math, Controls, Classes, StdCtrls, ComCtrls;

type
  TMojForm = class(TForm)
    listBox: TListBox;
    scrollBar: TScrollBar;
    procedure FormCreate(Sender: TObject);
    procedure scrollBarScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    lista : TStringList;
    function ObliczIlePozycjiMaBycWidocznych() : Integer;
    function ObliczMAXScrollBara() : Integer;

    procedure WyswietlXelementowWKontrolce(const ile_elementow : Word; const startIndex : Integer);
    procedure DodajDoListyXelementow(const ile_elementow : Integer);
  public
    { Public declarations }
  end;

var
  MojForm: TMojForm;

implementation

{$R *.dfm}


procedure TMojForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//na zakoczenie programu zwalniana jest pami zajmowana przez list
if (Self.lista <> nil) then
   FreeAndNil(Self.lista);
end;

procedure TMojForm.FormCreate(Sender: TObject);
var ile_elementow : Integer;
begin
//inicjalizacja listy
Self.lista := TStringList.Create();

//okrelenie ile elementw ma znajdowa si na licie
ile_elementow := 1000000;

//wypenienie listy milionem elementw
//wypenienie odbywa si w procedurze
Self.DodajDoListyXelementow(ile_elementow);
end;

procedure TMojForm.FormResize(Sender: TObject);
begin
scrollBar.Max := Self.ObliczMAXScrollBara();
scrollBar.Position := 0;

Self.WyswietlXelementowWKontrolce(Self.ObliczIlePozycjiMaBycWidocznych(), 0);
end;

procedure TMojForm.FormShow(Sender: TObject);
begin
Self.WyswietlXelementowWKontrolce(Self.ObliczIlePozycjiMaBycWidocznych(), 0);
end;

procedure TMojForm.scrollBarScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
var ile : Integer;
begin
//ilo widocznych pozycji w scrollBarze mona wyliczy
//jeden raz ale tylko w przypadku gdy jego rozmiar jest stay
//w przeciwnym wypadku (jak poniej) rozmiar liczony jest
//za kadym razem
ile := Self.ObliczIlePozycjiMaBycWidocznych();

//wypenienie listBoxa okrelon iloci elementw
Self.WyswietlXelementowWKontrolce(ile, ScrollPos);
end;

procedure TMojForm.DodajDoListyXelementow(const ile_elementow : Integer);
var i : Integer;
begin
//wypenienie listy przekazan iloci elementw
for i := 0 to ile_elementow-1 do
  Self.lista.Append(IntToStr(i+1));

//obliczenie MAX dla ScrollBar-a
//wane jest aby robi to po kadej zmianie
//iloci elementw na licie
scrollBar.Max := Self.ObliczMAXScrollBara();
end;

function TMojForm.ObliczIlePozycjiMaBycWidocznych() : Integer;
begin
Result := Floor(listBox.ClientHeight / listBox.ItemHeight) - 1;
end;

function TMojForm.ObliczMAXScrollBara() : Integer;
begin
Result := Self.lista.Count-1 - Self.ObliczIlePozycjiMaBycWidocznych();
end;

procedure TMojForm.WyswietlXelementowWKontrolce(const ile_elementow : Word; const startIndex : Integer);
var i : Integer;
begin
//czyszczenie zawartoci listBoxa
listBox.Items.Clear();

//wstawienie okrelonej iloci elementw do kontrolki
for i := startIndex to startIndex + ile_elementow do
  listBox.Items.Add(Self.lista[i]);
end;

end.
